import{isEmpty,deepClone,createElementsFromString}from"../../../base/helpers.mjs";import{ElementBuilder}from"../../../base/builder.mjs";import{FormView}from"../../base.mjs";import{InputView}from"../base.mjs";import{StringInputView,TextInputView}from"../string.mjs";import{NumberInputView,FloatInputView}from"../numeric.mjs";import{FormInputView,RepeatableInputView}from"../parent.mjs";import{SelectInputView,SearchListInputView,SearchListInputListView}from"../enumerable.mjs";const E=new ElementBuilder;class ModelPickerListInputView extends SearchListInputListView{static classList=SearchListInputListView.classList.concat(["model-picker-list-input-view"])}class ModelPickerStringInputView extends StringInputView{setValue(e,t){return isEmpty(e)||(e.startsWith("<")?e=createElementsFromString(e)[0].innerText:-1!==e.indexOf("/")&&(e=e.split("/")[1])),super.setValue(e,t)}}class ModelPickerInputView extends SearchListInputView{static placeholder="Start typing to search models…";static stringInputClass=ModelPickerStringInputView;static listInputClass=ModelPickerListInputView}class DefaultVaeInputView extends SelectInputView{static defaultOptions={ema:"EMA 560000",mse:"MSE 840000",consistency:"Consistency Decoder",xl:"SDXL",xl16:"SDXL FP16",other:"Other"};static placeholder="Default";static allowEmpty=!0;static tooltip="Variational Autoencoders are the model that translates images between pixel space - images that you can see - and latent space - images that the AI model understands. In general you do not need to select a particular VAE model, but you may find slight differences in sharpness of resulting images."}class VaeInputView extends InputView{static tagName="enfugue-vae-input-view";static selectClass=DefaultVaeInputView;static textClass=StringInputView;static textInputConfig={placeholder:"e.g. stabilityai/sdxl-vae",tooltip:"Enter the name of a HuggingFace repository housing the VAE configuration. Visit https://huggingface.co for more information."};constructor(e,t,i){super(e,t,i),this.defaultInput=new this.constructor.selectClass(e,"default"),this.otherInput=new this.constructor.textClass(e,"other",this.constructor.textInputConfig),this.defaultInput.onChange((()=>{let e=this.defaultInput.getValue();"other"===e?(this.value="",this.otherInput.show()):(this.value=e,this.otherInput.hide()),this.changed()})),this.otherInput.onChange((()=>{"other"===this.defaultInput.getValue()&&(this.value,this.otherInput.getValue(),this.changed())})),this.otherInput.hide()}getValue(){let e=this.defaultInput.getValue();return"other"===e?this.otherInput.getValue():e}setValue(e,t){super.setValue(e,!1),isEmpty(e)?(this.defaultInput.setValue(null,!1),this.otherInput.setValue("",!1),this.otherInput.hide()):-1===Object.getOwnPropertyNames(DefaultVaeInputView.defaultOptions).indexOf(e)?(this.defaultInput.setValue("other",!1),this.otherInput.setValue(e,!1),this.otherInput.show()):(this.defaultInput.setValue(e,!1),this.otherInput.setValue("",!1),this.otherInput.hide()),t&&this.changed()}async build(){return(await super.build()).content(await this.defaultInput.getNode(),await this.otherInput.getNode())}}class ModelInputView extends SearchListInputView{static stringInputClass=ModelPickerStringInputView;async setValue(e){if(await super.setValue(e),void 0!==this.node){let e=this.node.find(".show-metadata");isEmpty(this.value)?e.hide():e.show()}}async showMetadata(){this.showingMetadata=!0,await this.constructor.showModelMetadata(this.value),this.showingMetadata=!1}async build(){let e=await super.build(),t=E.i().class("fa-solid fa-magnifying-glass show-metadata").data("tooltip","View Model Metadata").on("click",(e=>{e.stopPropagation(),e.preventDefault(),!0!==this.showingMetadata&&this.showMetadata()}));return e.append(t),this.onChange((()=>{isEmpty(this.value)?t.hide():t.show()})),isEmpty(this.value)&&t.hide(),e}}class LoraInputView extends ModelInputView{}class LycorisInputView extends ModelInputView{}class InversionInputView extends ModelInputView{}class CheckpointInputView extends ModelInputView{}class MotionModuleInputView extends ModelInputView{}class LoraFormView extends FormView{static autoSubmit=!0;static fieldSets={LoRA:{model:{label:"Model",class:LoraInputView,config:{required:!0}},weight:{label:"Weight",class:FloatInputView,config:{min:0,value:1,step:.01,required:!0}}}}}class LoraFormInputView extends FormInputView{static formClass=LoraFormView}class LycorisFormView extends FormView{static autoSubmit=!0;static fieldSets={LyCORIS:{model:{label:"Model",class:LycorisInputView,config:{required:!0}},weight:{label:"Weight",class:FloatInputView,config:{min:0,value:1,step:.01,required:!0}}}}}class LycorisFormInputView extends FormInputView{static formClass=LycorisFormView}class MultiLoraInputView extends RepeatableInputView{static noItemsLabel="No LoRA Configured";static addItemLabel="Add LoRA";static memberClass=LoraFormInputView}class MultiLycorisInputView extends RepeatableInputView{static noItemsLabel="No LyCORIS Configured";static addItemLabel="Add LyCORIS";static memberClass=LycorisFormInputView}class MultiInversionInputView extends RepeatableInputView{static noItemsLabel="No Textual Inversion Configured";static addItemLabel="Add Textual Inversion";static memberClass=InversionInputView}class ModelMergeModeInputView extends SelectInputView{static defaultOptions={"add-difference":"Add Difference","weighted-sum":"Weighted Sum"}}class ModelTypeInputView extends SelectInputView{static defaultOptions={checkpoint:"Checkpoint",lora:"LoRA",lycoris:"LyCORIS",inversion:"Textual Inversion",motion:"Motion Module"}}export{CheckpointInputView,LoraInputView,LycorisInputView,InversionInputView,MultiLoraInputView,MultiLycorisInputView,MultiInversionInputView,VaeInputView,DefaultVaeInputView,ModelPickerStringInputView,ModelPickerListInputView,ModelPickerInputView,ModelMergeModeInputView,MotionModuleInputView,ModelTypeInputView};
